diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index 1b7b5f9c7..5e2d5fff6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -1,52 +1,58 @@
 package net.minecraft.client.render.texture.stitcher;
 
-import java.awt.AlphaComposite;
-import java.awt.Graphics2D;
+import java.awt.*;
 import java.awt.image.BufferedImage;
 import java.io.IOException;
 import java.io.InputStream;
 import java.net.URISyntaxException;
-import java.util.ArrayList;
-import java.util.Collections;
 import java.util.List;
 import java.util.Map;
-import java.util.concurrent.Callable;
-import java.util.concurrent.ExecutionException;
-import java.util.concurrent.ExecutorService;
-import java.util.concurrent.Executors;
-import java.util.concurrent.Future;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
+import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.customatlas.CustomAtlasHandler;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.render.texturepack.TexturePack;
-import net.minecraft.client.render.texturepack.TexturePackList;
+import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 
-import net.minecraft.client.render.customatlas.CustomAtlasHandler;
-import net.minecraft.client.util.helper.Textures;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Math;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
-public class AtlasStitcher extends Texture {
+public class AtlasStitcher {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final String rootAssetPath = "/assets";
-    public @NotNull Map<NamespaceID, IconCoordinate> textureMap = new Object2ObjectOpenHashMap<>();
+    public @NotNull Map<NamespaceID, IconCoordinate> iconMap = new Object2ObjectOpenHashMap<>();
     public @NotNull Map<String, String> idDirMap = new Object2ObjectOpenHashMap<>();
-    public final @Nullable BufferedImage defaultTexture;
-    public BufferedImage atlas;
+
+    public @NotNull Map<String, String> layerPostfixMap = new Object2ObjectOpenHashMap<>();
+    public @NotNull Map<String, BufferedImage> layerImageMap = new Object2ObjectOpenHashMap<>();
+    public @NotNull Map<String, Texture> layerTextureMap = new Object2ObjectOpenHashMap<>();
+    public @NotNull Object2IntMap<String> layerDefaultColorMap = new Object2IntOpenHashMap<>();
+
+    public BufferedImage colorImage;
+    public final @NotNull Texture colorTexture;
     private int atlasWidth;
     private int atlasHeight;
     private double invWidth;
     private double invHeight;
     private final boolean mipmap;
     private final boolean tickPaused;
-    public AtlasStitcher(boolean tickWhenPaused, boolean mipmap, @Nullable BufferedImage defaultTexture){
+
+    public AtlasStitcher(boolean tickWhenPaused, boolean mipmap) {
         this.tickPaused = tickWhenPaused;
         this.mipmap = mipmap;
-        this.defaultTexture = defaultTexture;
+
+        addLayer("color", "", 0xFFFF00FF);
+        this.colorTexture = this.layerTextureMap.get("color");
     }
 
     public @NotNull AtlasStitcher addDirectory(@NotNull String id, @NotNull String path) {
@@ -54,21 +60,28 @@ public class AtlasStitcher extends Texture {
         return this;
     }
 
-    protected @NotNull IconCoordinate getTexture(@NotNull NamespaceID id){
-        IconCoordinate cached = this.textureMap.get(id); // Changed to read cached value this way as somehow this method previously managed to return null https://bugs.betterthanadventure.net/scp/tickets.php?id=246
+    public @NotNull AtlasStitcher addLayer(@NotNull String id, @NotNull String filePostfix, int defaultColor) {
+        this.layerPostfixMap.put(id, filePostfix);
+        this.layerTextureMap.put(id, new Texture());
+        this.layerDefaultColorMap.put(id, defaultColor);
+        return this;
+    }
+
+    protected @NotNull IconCoordinate getTexture(@NotNull NamespaceID id) {
+        IconCoordinate cached = this.iconMap.get(id); // Changed to read cached value this way as somehow this method previously managed to return null https://bugs.betterthanadventure.net/scp/tickets.php?id=246
         if (cached != null) return cached;
 
-        IconCoordinate iconCoordinate = new IconCoordinate(this, id, getSourceImagePath(id));
-        this.textureMap.put(id, iconCoordinate);
+        IconCoordinate iconCoordinate = new IconCoordinate(this, id);
+        this.iconMap.put(id, iconCoordinate);
         return iconCoordinate;
     }
 
-    public @NotNull String getSourceImagePath(@NotNull NamespaceID id){
+    public @NotNull String getSourceImageId(@NotNull NamespaceID id) {
         String value = id.value();
         int slashIndex = value.indexOf("/");
         if (slashIndex != -1) {
             String dir = this.idDirMap.get(value.substring(0, slashIndex));
-            return String.format("%s/%s/%s/%s.png", rootAssetPath, id.namespace(), dir, value.substring(slashIndex + 1));
+            return String.format("%s/%s/%s/%s", rootAssetPath, id.namespace(), dir, value.substring(slashIndex + 1));
         } else {
             throw new IllegalArgumentException("Id " + id + " does not specify an id!");
         }
@@ -81,146 +94,273 @@ public class AtlasStitcher extends Texture {
             String[] paths = TextureRegistry.getFilesAndSubFiles(folder, searchSubDirectories);
 
             for (String p : paths) {
-                getTexture(new NamespaceID(namespace, e.getKey() + "/" + p.replace(".png", "")));
+                if (p.contains(".") && p.lastIndexOf(".") == p.indexOf(".")) {
+                    getTexture(new NamespaceID(namespace, e.getKey() + "/" + p.replace(".png", "")));
+                }
             }
         }
     }
 
+    private final List<Box> boxes = new ObjectArrayList<>();
     public void preinit() {
-        generate();
-        long startTime = System.nanoTime();
-        Minecraft mc = Minecraft.getMinecraft();
-        List<IconCoordinate> coordinateList = new ArrayList<>(this.textureMap.values());
-        List<Future<?>> futures = new ArrayList<>();
-        ExecutorService service = Executors.newFixedThreadPool(32);
-        for (IconCoordinate coordinate : coordinateList){
-            futures.add(service.submit(new SetupTexture(mc.texturePackList, coordinate, this.defaultTexture)));
-        }
-
-        for (Future<?> f : futures) {
-            try {
-                f.get();
-            } catch (InterruptedException | ExecutionException e) {
-                LOGGER.error("", e);
-            }
+        this.boxes.clear();
+
+        for (IconCoordinate coordinate : this.iconMap.values()) {
+            Box box = new Box(Minecraft.getMinecraft(), this, coordinate, null);
+            this.boxes.add(box);
+            coordinate.setDimension(box.image.getWidth(), box.image.getHeight());
         }
-        service.shutdown();
-        LOGGER.debug("Took '{}' seconds to load images.", (System.nanoTime() - startTime) / 1_000_000_000d);
     }
 
-    @Override
-    public void init(){
-        // Load all individual textures and the store the widths
-        int area = 0;
+    public void init() {
         int maxWidth = 0;
-        List<IconCoordinate> coordinateList = new ArrayList<>(this.textureMap.values());
-        for (IconCoordinate coordinate : coordinateList){
-            if (coordinate.needsDimensions()) {
-                BufferedImage image = coordinate.getImageStorage();
-                coordinate.setDimension(image.getWidth(), image.getHeight());
+        int maxHeight = 0;
+        for (Box box : this.boxes) {
+            maxWidth = Math.max(maxWidth, box.coord.width + box.border * 2);
+            maxHeight = Math.max(maxHeight, box.coord.height + box.border * 2);
+        }
+
+        this.boxes.sort((o1, o2) -> {
+            int diff = o2.coord.height - o1.coord.height;
+            if (diff != 0) return diff;
+            return o1.coord.namespaceId.compareTo(o2.coord.namespaceId);
+        });
+
+        int atlasWidth = Math.max(Integer.highestOneBit(maxWidth) << 1, 256);
+        int atlasHeight = Math.max(Integer.highestOneBit(maxHeight) << 1, 256);
+
+        ObjectArrayList<Space> spaces = new ObjectArrayList<>(); spaces.add(new Space(0, 0, atlasWidth, atlasHeight));
+        List<Box> packed = new ObjectArrayList<>();
+
+        for (Box box : this.boxes) {
+            expand: while(true) {
+                for (int i = spaces.size() - 1; i >= 0; i--) {
+                    var space = spaces.get(i);
+
+                    if (box.coord.width + box.border * 2 > space.w || box.coord.height + box.border * 2 > space.h) continue;
+
+                    packed.add(box);
+                    box.x = space.x;
+                    box.y = space.y;
+
+                    if (box.coord.width + box.border * 2 == space.w && box.coord.height + box.border * 2 == space.h) {
+                        var last = spaces.remove(spaces.size() - 1);
+                        if (i < spaces.size()) spaces.set(i, last);
+                    } else if (box.coord.height == space.h) {
+                        space.x += box.coord.width + box.border * 2;
+                        space.w -= box.coord.width + box.border * 2;
+                    } else if (box.coord.width + box.border * 2 == space.w) {
+                        space.y += box.coord.height + box.border * 2;
+                        space.h -= box.coord.height + box.border * 2;
+                    } else{
+                        spaces.add(new Space(space.x + box.coord.width + box.border * 2, space.y, space.w - (box.coord.width + box.border * 2), box.coord.height + box.border * 2));
+                        space.y += box.coord.height + box.border * 2;
+                        space.h -= box.coord.height + box.border * 2;
+                    }
+                    break expand;
+                }
+                if (atlasWidth <= atlasHeight) {
+                    spaces.add(0, new Space(atlasWidth, 0, atlasWidth, atlasHeight));
+                    atlasWidth *= 2;
+                } else{
+                    spaces.add(0, new Space(0, atlasHeight, atlasWidth, atlasHeight));
+                    atlasHeight *= 2;
+                }
             }
-            area += coordinate.getArea();
-            if (coordinate.width > maxWidth) maxWidth = coordinate.width;
-        }
-        // Calculate an okay atlas width to keep the aspect ratio of the final atlas mostly 1:1
-        int targetWidth = Integer.highestOneBit((int) Math.max(Math.ceil(Math.sqrt(area)), maxWidth)) << 1;
-        Collections.sort(coordinateList);
-
-        // Find positions for each texture on the atlas
-        int nextX = 0;
-        int currentY = 0;
-        int nextY = coordinateList.get(0).height;
-        int maxRealWidth = 0;
-        for (IconCoordinate coordinate : coordinateList){
-            if (nextX + coordinate.width > targetWidth){
-                nextX = 0;
-                currentY = nextY;
-                nextY += coordinate.height;
+        }
+
+        for (Box box : packed) {
+            box.coord.setPosition(box.x, box.y);
+        }
+
+        for (Map.Entry<String, String> e : this.layerPostfixMap.entrySet()) {
+            BufferedImage atlas = new BufferedImage(atlasWidth, atlasHeight, BufferedImage.TYPE_INT_ARGB);
+            Graphics2D g = atlas.createGraphics();
+            this.layerImageMap.put(e.getKey(), atlas);
+
+            for (Box box : packed) {
+                BufferedImage image = getImage(e.getKey(), box.coord);
+
+                BufferedImage _subImage = new BufferedImage(box.coord.width, box.coord.height, BufferedImage.TYPE_INT_ARGB);
+                _subImage.setRGB(0, 0, _subImage.getWidth(), _subImage.getHeight(),
+                    image.getRGB(0, 0, _subImage.getWidth(), _subImage.getHeight(), new int[_subImage.getWidth() * _subImage.getHeight()], 0, _subImage.getWidth()),
+                    0, _subImage.getWidth());
+                g.drawImage(_subImage, box.x, box.y, null);
+            }
+            g.dispose();
+
+            Texture t = this.layerTextureMap.get(e.getKey());
+            if (!t.isGenerated()) {
+                t.generate();
             }
-            coordinate.setPosition(nextX, currentY);
-            nextX += coordinate.width;
-            if (nextX > maxRealWidth) maxRealWidth = nextX;
+            t.setupTexture(atlas, false, false, this.mipmap);
         }
 
-        // Generate and then copy the data to a new image with the dimensions needed
-        BufferedImage generatedAtlas = new BufferedImage(targetWidth, Integer.highestOneBit(nextY) << 1, BufferedImage.TYPE_INT_ARGB);
+        this.colorImage = this.layerImageMap.get("color");
 
-        this.atlasWidth = generatedAtlas.getWidth();
-        this.atlasHeight = generatedAtlas.getHeight();
-        this.invWidth = 1d/ this.atlasWidth;
-        this.invHeight = 1d/ this.atlasHeight;
+        this.atlasWidth = atlasWidth;
+        this.atlasHeight = atlasHeight;
+        this.invWidth = 1d / this.atlasWidth;
+        this.invHeight = 1d / this.atlasHeight;
 
-        Graphics2D atlas = generatedAtlas.createGraphics();
-        atlas.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1f));
-        for (IconCoordinate coordinate : coordinateList){
-            coordinate.drawToAtlas(atlas);
-            coordinate.discardImage();
+        for (Box box : packed) {
+            box.coord.cacheUVs();
         }
-        atlas.dispose();
+    }
+
+    public BufferedImage getImage(@NotNull String layer, @NotNull IconCoordinate coordinate) {
+        String source = getSourceImageId(coordinate.namespaceId);
+        String postfix = this.layerPostfixMap.getOrDefault(layer, "");
+        String path;
+        if (postfix.isEmpty()) {
+            path = source + ".png";
+        } else {
+            path = source + "." + postfix + ".png";
+        }
+        BufferedImage image = CustomAtlasHandler.getTextureOverride(Minecraft.getMinecraft().texturePackList, source + "png");
+        if(image == null) {
+            TexturePack pack = Minecraft.getMinecraft().texturePackList.getHighestPriorityTexturePackWithFile(source + ".png");
+            if (pack != null) {
+                for (int attempt = 0; attempt < 3; attempt++) {
+                    try {
+                        image = Textures.readImageUnhandled(pack.getResourceAsStream(path));
+                        if (image != null) break;
+                    } catch (Exception e) {
+                        LOGGER.error("", e);
+                    }
+                }
+            }
+        }
+        if (image == null || image == Textures.missingTexture){
+            image = new BufferedImage(coordinate.width, coordinate.height, BufferedImage.TYPE_INT_ARGB);
+            int defaultColor = layerDefaultColorMap.getOrDefault(layer, 0xFFFF00FF);
+            for (int x = 0; x < image.getWidth(); x++) {
+                for (int y = 0; y < image.getHeight(); y++) {
+                    image.setRGB(x, y, defaultColor);
+                }
+            }
+            return image;
+        }
+        return image;
+    }
 
-        setupTexture(generatedAtlas, false, false, this.mipmap);
+    public int[] getIconData(@NotNull String layer, @NotNull IconCoordinate coordinate, int[] dest) {
+        BufferedImage img = this.layerImageMap.get(layer);
+        if (img != null) {
+            assert dest.length >= coordinate.getArea();
+            img.getRGB(coordinate.iconX, coordinate.iconY, coordinate.width, coordinate.height, dest, 0, coordinate.width);
+        }
+        return dest;
+    }
 
-        this.atlas = generatedAtlas;
+    public void bind() {
+        this.colorTexture.bind();
+    }
+
+    public void bind(@NotNull String layer) {
+        Texture t = this.layerTextureMap.get(layer);
+        if (t != null) {
+            t.bind();
+        } else {
+            GL41.glBindTexture(GL41.GL_TEXTURE_2D, 0);
+        }
     }
 
-    public int getAtlasWidth(){
+    public int getAtlasWidth() {
         return this.atlasWidth;
     }
-    public int getAtlasHeight(){
+
+    public int getAtlasHeight() {
         return this.atlasHeight;
     }
-    public double getInverseWidth(){
+
+    public double getInverseWidth() {
         return this.invWidth;
     }
-    public double getInverseHeight(){
+
+    public double getInverseHeight() {
         return this.invHeight;
     }
-    public boolean tickWhenPaused() {return this.tickPaused;}
-    public boolean hasMipmaps() {return this.mipmap;}
-
-    public static class SetupTexture implements Callable<IconCoordinate> {
-        private final @NotNull TexturePackList packList;
-        private final @NotNull IconCoordinate coordinate;
-        private final @Nullable BufferedImage defaultTexture;
-        public SetupTexture(@NotNull TexturePackList packList, @NotNull IconCoordinate coordinate, @Nullable BufferedImage defaultTexture) {
-            this.packList = packList;
-            this.coordinate = coordinate;
-            this.defaultTexture = defaultTexture;
-        }
-        @Override
-        public IconCoordinate call() {
-            this.coordinate.resetMetadata();
-            BufferedImage image = CustomAtlasHandler.getTextureOverride(this.packList, this.coordinate.sourceImagePath);
+
+    public boolean tickWhenPaused() {
+        return this.tickPaused;
+    }
+
+    public boolean hasMipmaps() {
+        return this.mipmap;
+    }
+
+    private static class Space {
+        private int x;
+        private int y;
+        private int w;
+        private int h;
+
+        public Space(int x, int y, int w, int h) {
+            this.x = x;
+            this.y = y;
+            this.w = w;
+            this.h = h;
+        }
+    }
+
+    private static class Box {
+
+        private int x;
+        private int y;
+        private int border;
+        @NotNull
+        private final IconCoordinate coord;
+        @NotNull
+        private final BufferedImage image;
+        @Nullable
+        private TexturePack pack;
+
+        public Box(@NotNull Minecraft mc, @NotNull AtlasStitcher atlasStitcher, @NotNull IconCoordinate coordinate, @Nullable BufferedImage defaultTexture) {
+            coordinate.resetMetadata();
+            String path = atlasStitcher.getSourceImageId(coordinate.namespaceId) + ".png";
+            BufferedImage image = CustomAtlasHandler.getTextureOverride(mc.texturePackList, path);
             if(image == null) {
-                TexturePack pack = this.packList.getHighestPriorityTexturePackWithFile(this.coordinate.sourceImagePath);
+                TexturePack pack = mc.texturePackList.getHighestPriorityTexturePackWithFile(path);
                 if (pack != null) {
+                    this.pack = pack;
                     for (int attempt = 0; attempt < 3; attempt++) {
                         try {
-                            image = Textures.readImageUnhandled(pack.getResourceAsStream(this.coordinate.sourceImagePath));
+                            image = Textures.readImageUnhandled(pack.getResourceAsStream(path));
                             if (image != null) break;
                         } catch (Exception e) {
                             LOGGER.error("", e);
                         }
                     }
-                    String metaPath = this.coordinate.sourceImagePath + ".mcmeta";
+                    String metaPath = path + ".mcmeta";
                     if (pack.hasFile(metaPath)) {
                         try (InputStream stream = pack.getResourceAsStream(metaPath)){
-                            this.coordinate.initMetadata(stream);
+                            coordinate.initMetadata(stream);
                         } catch (Exception e) {
-                            LOGGER.error("Failed to initiate metadata for '{}'!", this.coordinate.namespaceId, e);
+                            LOGGER.error("Failed to initiate metadata for '{}'!", coordinate.namespaceId, e);
                         }
                     }
                 }
             }
             if (image == null || image == Textures.missingTexture){
-                LOGGER.warn("{} could not be found!", this.coordinate.sourceImagePath);
-                if (this.defaultTexture != null){
-                    image = this.defaultTexture;
+                LOGGER.warn("{} could not be found!", path);
+                if (defaultTexture != null){
+                    image = defaultTexture;
                 }
                 if (image == null) image = Textures.missingTexture; // If this ever happens I'll be very sad
             }
-            this.coordinate.setImage(image);
-            return this.coordinate;
+            this.image = image;
+            this.coord = coordinate;
+        }
+
+        public Box(int x, int y, int border, @NotNull IconCoordinate coord, @NotNull BufferedImage image, @NotNull TexturePack pack) {
+            this.x = x;
+            this.y = y;
+            this.border = border;
+            this.coord = coord;
+            this.image = image;
+            this.pack = pack;
         }
     }
+
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index ccf2bee8b..dfc1f8c63 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -7,11 +7,9 @@ import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
-import java.awt.*;
-import java.awt.image.BufferedImage;
 import java.io.InputStream;
 
-public class IconCoordinate implements Comparable<IconCoordinate> {
+public class IconCoordinate {
     private static final Logger LOGGER = LogUtils.getLogger();
     public int iconX;
     public int iconY;
@@ -23,71 +21,36 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
     private double vMax;
     private double uSize;
     private double vSize;
-    private boolean pendingDimensions;
-    protected final @NotNull String sourceImagePath;
     protected final @NotNull TextureMetaHandler metaHandler = new TextureMetaHandler();
     public final @NotNull NamespaceID namespaceId;
     public final @NotNull AtlasStitcher parentAtlas;
-    private BufferedImage _imageStorage;
 
-    public IconCoordinate(@NotNull AtlasStitcher stitcher, @NotNull NamespaceID namespaceId, @NotNull String sourceImagePath) {
+    public IconCoordinate(@NotNull AtlasStitcher stitcher, @NotNull NamespaceID namespaceId) {
         this.parentAtlas = stitcher;
         this.namespaceId = namespaceId;
-        this.sourceImagePath = sourceImagePath;
-    }
-
-    protected void setImage(@NotNull BufferedImage image) {
-        assert image != null : "setImage cannot take null!";
-        this.pendingDimensions = true;
-        this._imageStorage = image;
-    }
-
-    // This will only ever return the actual image when used during a very narrow period of time
-    // Its very much for use with the atlas stitching process and dynamic textures
-    public BufferedImage getImageStorage() {
-        return this._imageStorage;
-    }
-
-    protected void discardImage() {
-        this.uMin = ((double) this.iconX) * this.parentAtlas.getInverseWidth();
-        this.uMax = ((double) this.iconX + width) * this.parentAtlas.getInverseWidth();
-        this.vMin = ((double) this.iconY) * this.parentAtlas.getInverseHeight();
-        this.vMax = ((double) this.iconY + height) * this.parentAtlas.getInverseHeight();
-        this.uSize = width * this.parentAtlas.getInverseWidth();
-        this.vSize = height * this.parentAtlas.getInverseHeight();
-
-        this._imageStorage = null;
-    }
-
-    public boolean needsDimensions() {
-        return this.pendingDimensions;
     }
 
     public void setDimension(int width, int height) {
         this.width = width;
         this.height = height;
-        this.pendingDimensions = false;
     }
 
-    public void setPosition(int x, int y) {
+    protected void setPosition(int x, int y) {
         this.iconX = x;
         this.iconY = y;
     }
 
-    public int getArea() {
-        return this.width * this.height;
+    protected void cacheUVs() {
+        this.uMin = ((double) this.iconX) * this.parentAtlas.getInverseWidth();
+        this.uMax = ((double) this.iconX + this.width) * this.parentAtlas.getInverseWidth();
+        this.vMin = ((double) this.iconY) * this.parentAtlas.getInverseHeight();
+        this.vMax = ((double) this.iconY + this.height) * this.parentAtlas.getInverseHeight();
+        this.uSize = this.width * this.parentAtlas.getInverseWidth();
+        this.vSize = this.height * this.parentAtlas.getInverseHeight();
     }
 
-    protected void drawToAtlas(Graphics2D atlas) {
-        assert this._imageStorage != null : "Image storage should not be null!! something went wrong with image '" + this.namespaceId + "' at '" + this.sourceImagePath + "'!";
-        if (this.width != this._imageStorage.getWidth() || this.height != this._imageStorage.getHeight()) {
-            int[] subImage = this._imageStorage.getRGB(0, 0, this.width, this.height, null, 0, this.width);
-            BufferedImage _img = new BufferedImage(this.width, this.height, BufferedImage.TYPE_INT_ARGB);
-            _img.setRGB(0, 0, this.width, this.height, subImage, 0, this.width);
-            atlas.drawImage(_img, this.iconX, this.iconY, null);
-            return;
-        }
-        atlas.drawImage(this._imageStorage, this.iconX, this.iconY, null);
+    public int getArea() {
+        return this.width * this.height;
     }
 
     public double getIconUMin() {
@@ -122,19 +85,8 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         return this.vSize;
     }
 
-    public String toString() {
-        return String.format("W:%d, H:%d, X:%d, Y:%d | ID:%s, Source:%s", this.width, this.height, this.iconX, this.iconY, this.namespaceId, this.sourceImagePath);
-    }
-
-    public String getImageSource() {
-        return this.sourceImagePath;
-    }
-
-    @Override
-    public int compareTo(@NotNull IconCoordinate o) {
-        int res = o.height - this.height;
-        if (res != 0) return res;
-        return this.namespaceId.compareTo(o.namespaceId);
+    public @NotNull String toString() {
+        return String.format("W:%d, H:%d, X:%d, Y:%d | ID:%s", this.width, this.height, this.iconX, this.iconY, this.namespaceId);
     }
 
     protected void resetMetadata() {
@@ -149,15 +101,15 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         }
     }
 
-    public boolean hasMeta(String key) {
+    public boolean hasMeta(@NotNull String key) {
         return this.metaHandler.has(key);
     }
 
-    public @Nullable <T> T getMeta(String key, Class<T> aClass) {
+    public @Nullable <T> T getMeta(@NotNull String key, @NotNull Class<T> aClass) {
         return this.metaHandler.get(key, aClass);
     }
 
-    public <T> T getOrDefaultMeta(String key, T metaDefault, Class<T> aClass) {
+    public <T> T getOrDefaultMeta(@NotNull String key, @NotNull T metaDefault, @NotNull Class<T> aClass) {
         return this.metaHandler.getOrDefault(key, metaDefault, aClass);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index 446c67f22..f5fee0b2c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -53,25 +53,27 @@ public class TextureRegistry {
 
     @SuppressWarnings("unused")
     public static AtlasStitcher worldAtlas = register(
-        new AtlasStitcher(false, true, missingIconImage)
+        new AtlasStitcher(false, true)
             .addDirectory("block", "textures/block")
             .addDirectory("item", "textures/item")
             .addDirectory("particle", "textures/particle")
+//            .addLayer("maskColor", "cmask", 0xFFFFFFFF)
+            .addLayer("emissive", "emiss", 0x00000000)
     );
 
     @SuppressWarnings("unused")
     public static AtlasStitcher artAtlas = register(
-        new AtlasStitcher(false, true, null)
+        new AtlasStitcher(false, true)
             .addDirectory("art", "textures/art")
     );
     @SuppressWarnings("unused")
     public static AtlasStitcher guiSpriteAtlas = register(
-        new AtlasStitcher(true, false, null)
+        new AtlasStitcher(true, false)
             .addDirectory("gui", "textures/gui/sprites")
     );
     @SuppressWarnings("unused")
     public static AtlasStitcher signAtlas = register(
-        new AtlasStitcher(false, false, null)
+        new AtlasStitcher(false, false)
             .addDirectory("sign", "textures/gui/sign")
     );
 
@@ -103,7 +105,7 @@ public class TextureRegistry {
         final AtlasStitcher atlas = stitcherMap.get(atlasId);
         if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + atlasId + "'!");
 
-        return atlas.textureMap.containsKey(NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
+        return atlas.iconMap.containsKey(NamespaceID.fromPool(id.namespace(), id.value().substring(slashIndex + 1)));
     }
     public static @NotNull AtlasStitcher register(@NotNull AtlasStitcher atlas){
         for (String id : atlas.idDirMap.keySet()) {
@@ -198,7 +200,7 @@ public class TextureRegistry {
                     writer.append("# Auto generated tiles mapping for atlas '").append(stitcherEntry.getKey()).append("'\n");
                     writer.append("# generated for version '").append(Global.VERSION).append("' at '").append(dateFormat.format(new Date())).append("'\n");
                     writer.append("size=").append(Integer.toString(stitcher.getAtlasWidth())).append("x").append(Integer.toString(stitcher.getAtlasHeight())).append("\n");
-                    for (final Map.Entry<NamespaceID, IconCoordinate> entry : stitcher.textureMap.entrySet()) {
+                    for (final Map.Entry<NamespaceID, IconCoordinate> entry : stitcher.iconMap.entrySet()) {
                         final IconCoordinate coordinate = entry.getValue();
                         writer.append(Integer.toString(coordinate.iconX)).append(",").append(Integer.toString(coordinate.iconY));
                         writer.append("=");
